Index: issm/trunk/src/c/analyses/AdjointHorizAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/AdjointHorizAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/AdjointHorizAnalysis.cpp	(revision 26744)
@@ -1155,4 +1694,5 @@
 				case SSAApproximationEnum: GradientJBSSA(element,gradient,control_interp,control_index); break;
 				case HOApproximationEnum:  GradientJBHO( element,gradient,control_interp,control_index); break;
+			//	case MLHOApproximationEnum:  GradientJBMLHO( element,gradient,control_interp,control_index); break;
 				case FSApproximationEnum:  GradientJBFS( element,gradient,control_interp,control_index); break;
 				case NoneApproximationEnum: /*Gradient is 0*/                    break;
@@ -1183,4 +1723,6 @@
 	int      domaintype;
 	Element* basalelement;
+
+	if(control_interp==P0Enum) _error_("cannot require regularization for P0 controls");
 
 	/*Get basal element*/
@@ -1250,5 +1792,5 @@
 	xDelete<int>(vertexpidlist);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void           AdjointHorizAnalysis::GradientJBbarL1L2(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
@@ -1261,4 +1803,132 @@
 	/*WARNING: We use SSA as an estimate for now*/
 	this->GradientJBbarSSA(element,gradient,control_interp,control_index);
+}/*}}}*/
+void           AdjointHorizAnalysis::GradientJBbarMLHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
+
+   if(control_interp!=P1Enum) _error_("not implemented yet...");
+	/*Intermediaries*/
+	int      domaintype,dim;
+	Element* basalelement;
+
+	/*Get basal element*/
+	element->FindParam(&domaintype,DomainTypeEnum);
+	switch(domaintype){
+		case Domain2DhorizontalEnum:
+			basalelement = element;
+			dim          = 2;
+			break;
+		case Domain2DverticalEnum:
+			if(!element->IsOnBase()) return;
+			basalelement = element->SpawnBasalElement();
+			dim          = 1;
+			break;
+		case Domain3DEnum:
+			if(!element->IsOnBase()) return;
+			basalelement = element->SpawnBasalElement(true);
+			dim          = 2;
+			break;
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+	}
+
+	/*Intermediaries*/
+	IssmDouble Jdet,weight;
+	IssmDouble thickness,dmudB,n;
+	IssmDouble dvx[3],dvy[3],dadjbx[3],dadjby[3],dadjshx[3],dadjshy[3]; 
+	IssmDouble *xyz_list= NULL;
+
+	/*Fetch number of vertices for this finite element*/
+	int numvertices = basalelement->GetNumberOfVertices();
+
+	/*Initialize some vectors*/
+	IssmDouble* basis         = xNew<IssmDouble>(numvertices);
+	IssmDouble* ge            = xNewZeroInit<IssmDouble>(numvertices);
+	int*        vertexpidlist = xNew<int>(numvertices);
+	IssmDouble  zeta;
+   IssmDouble  e1[3],e2[3], phishx[3], phishy[3];
+   IssmDouble  epsilon[5];/* epsilon=[exx,eyy,exy,exz,eyz];*/
+	IssmDouble  adjshx, adjshy;
+
+	/*Retrieve all inputs we will be needing: */
+	basalelement->GetVerticesCoordinates(&xyz_list);
+	basalelement->GradientIndexing(&vertexpidlist[0],control_index);
+	Input* thickness_input	= basalelement->GetInput(ThicknessEnum);					_assert_(thickness_input);
+   Input* n_input				= basalelement->GetInput(MaterialsRheologyNEnum);		_assert_(n_input);
+   Input* vxbase_input		= basalelement->GetInput(VxBaseEnum);						_assert_(vxbase_input);
+   Input* vybase_input		= basalelement->GetInput(VyBaseEnum);						_assert_(vybase_input);
+   Input* vxshear_input		= basalelement->GetInput(VxShearEnum);						_assert_(vxshear_input);
+   Input* vyshear_input		= basalelement->GetInput(VyShearEnum);						_assert_(vyshear_input);
+
+	Input* adjointbx_input	= basalelement->GetInput(AdjointxBaseEnum);				_assert_(adjointbx_input);
+	Input* adjointby_input	= basalelement->GetInput(AdjointyBaseEnum);				_assert_(adjointby_input);
+	Input* adjointshx_input	= basalelement->GetInput(AdjointxShearEnum);				_assert_(adjointshx_input);
+	Input* adjointshy_input	= basalelement->GetInput(AdjointyShearEnum);				_assert_(adjointshy_input);
+
+	/* Start  looping on the number of gaussian points: */
+	Gauss* gauss=basalelement->NewGauss(5);
+   GaussSeg* gauss_seg=new GaussSeg(2);
+
+	while(gauss->next()){
+
+		thickness_input->GetInputValue(&thickness,gauss);
+	   n_input->GetInputValue(&n,gauss);
+		adjointbx_input->GetInputDerivativeValue(&dadjbx[0],xyz_list,gauss);
+		adjointby_input->GetInputDerivativeValue(&dadjby[0],xyz_list,gauss);
+		adjointshx_input->GetInputDerivativeValue(&dadjshx[0],xyz_list,gauss);
+		adjointshy_input->GetInputDerivativeValue(&dadjshy[0],xyz_list,gauss);
+		adjointshx_input->GetInputValue(&adjshx, gauss);
+		adjointshy_input->GetInputValue(&adjshy, gauss);
+		
+		basalelement->JacobianDeterminant(&Jdet,xyz_list,gauss);
+		basalelement->NodalFunctionsP1(basis,gauss);
+
+	   /* Get the integration in the vertical direction */
+      gauss_seg->Reset();
+      while(gauss_seg->next()){
+			zeta=0.5*(gauss_seg->coord1+1);
+
+			basalelement->StrainRateMLHO(&epsilon[0],xyz_list,gauss,
+                  vxbase_input,vybase_input,vxshear_input,vyshear_input,thickness_input,n_input,zeta);
+
+			basalelement->dViscositydBMLHO(&dmudB,dim,xyz_list,gauss,vxbase_input,vybase_input,vxshear_input,vyshear_input,thickness_input,n_input,zeta);
+
+			e1[0] = 2.0*epsilon[0]+epsilon[1];
+         e1[1] = epsilon[2];
+         e1[2] = epsilon[3];
+
+         e2[0] = epsilon[2];
+         e2[1] = epsilon[0]+2.0*epsilon[1];
+         e2[2] = epsilon[4];
+
+			phishx[0] = dadjbx[0] + (1-pow(zeta, n+1))*dadjshx[0];
+			phishx[1] = dadjbx[1] + (1-pow(zeta, n+1))*dadjshx[1];
+			phishx[2] = (n+1)/thickness*pow(zeta, n)*adjshx;
+			phishy[0] = dadjby[0] + (1-pow(zeta, n+1))*dadjshy[0];
+			phishy[1] = dadjby[1] + (1-pow(zeta, n+1))*dadjshy[1];
+			phishy[2] = (n+1)/thickness*pow(zeta, n)*adjshy;
+
+			/*Build gradient vector (actually -dJ/dB): */
+			for(int i=0;i<numvertices;i++){
+				for (int j=0;j<3;j++){
+					ge[i]+=(-dmudB)*2*(e1[j]*phishx[j]+e2[j]*phishy[j])*Jdet*gauss->weight*basis[i]*thickness*0.5*gauss_seg->weight;
+					_assert_(!xIsNan<IssmDouble>(ge[i]));
+				}
+			}
+		}
+	}
+	if(control_interp==P1Enum){
+		gradient->SetValues(numvertices,vertexpidlist,ge,ADD_VAL);
+	}
+	else{
+		_error_("not supported");
+	}
+
+	/*Clean up and return*/
+	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(basis);
+	xDelete<IssmDouble>(ge);
+	xDelete<int>(vertexpidlist);
+	delete gauss;
+	delete gauss_seg;
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void           AdjointHorizAnalysis::GradientJBbarSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
@@ -1362,5 +2032,5 @@
 	xDelete<int>(vertexpidlist);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void           AdjointHorizAnalysis::GradientJBFS(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
@@ -1372,4 +2042,6 @@
 	/*Intermediaries*/
 	int      domaintype;
+
+	if(control_interp==P0Enum) _error_("cannot require regularization for P0 controls");
 
 	/*Get basal element*/
@@ -1437,4 +2109,5 @@
 	/*Intermediaries*/
 	int      domaintype;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Get basal element*/
@@ -1499,4 +2172,5 @@
 	/*Intermediaries*/
 	int      domaintype,dim;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Get domaintype*/
@@ -1571,4 +2245,7 @@
 	delete gauss;
 }/*}}}*/
+void           AdjointHorizAnalysis::GradientJBMLHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
+	_error_("not implemented yet...");
+}/*}}}*/
 void           AdjointHorizAnalysis::GradientJBSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
 
@@ -1576,4 +2253,5 @@
 	int      domaintype,dim;
 	Element* basalelement;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Get basal element*/
@@ -1652,14 +2330,14 @@
 	xDelete<int>(vertexpidlist);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void           AdjointHorizAnalysis::GradientJDragGradient(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
 
 	/*return if floating (gradient is 0)*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
+	if(control_interp==P0Enum) _error_("cannot require regularization for P0 controls");
 
 	/*Intermediaries*/
 	int      domaintype,dim;
-	int frictionlaw;
 	Element* basalelement;
 
@@ -1702,5 +2380,5 @@
 
 	/* get the friction law: if 2-Weertman, 11-Schoof, use a special name for the coefficient*/
-	element->FindParam(&frictionlaw, FrictionLawEnum);
+	int frictionlaw; element->FindParam(&frictionlaw, FrictionLawEnum);
 	Input* dragcoefficient_input;
 	switch(frictionlaw) {
@@ -1745,5 +2423,5 @@
 	xDelete<int>(vertexpidlist);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 
 }/*}}}*/
@@ -1751,6 +2429,7 @@
 
 	/*return if floating or not on bed (gradient is 0)*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 	if(!element->IsOnBase()) return;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Intermediaries*/
@@ -1790,5 +2469,18 @@
 		adjointz_input  = element->GetInput(AdjointzEnum);             _assert_(adjointz_input);
 	}
-	Input* dragcoeff_input = element->GetInput(FrictionCoefficientEnum);  _assert_(dragcoeff_input);
+	/* get the friction law: 1- Budd, 11-Schoof*/
+	int frictionlaw; element->FindParam(&frictionlaw, FrictionLawEnum);
+	Input* dragcoeff_input = NULL;
+	switch(frictionlaw) {
+		case 1:
+			dragcoeff_input = element->GetInput(FrictionCoefficientEnum); _assert_(dragcoeff_input);
+			break;
+		case 2:
+		case 11:
+			dragcoeff_input = element->GetInput(FrictionCEnum); _assert_(dragcoeff_input);
+			break;
+		default:
+			_error_("Friction law "<< frictionlaw <<" not supported in the inversion.");
+	}
 
 	/* Start  looping on the number of gaussian points: */
@@ -1851,5 +2543,5 @@
 
 	/*return if floating or not on bed (gradient is 0)*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 	if(!element->IsOnBase()) return;
 
@@ -1882,9 +2574,23 @@
 	Input* adjointx_input  = element->GetInput(AdjointxEnum);             _assert_(adjointx_input);
 	Input* adjointy_input  = NULL;
-	Input* dragcoeff_input = element->GetInput(FrictionCoefficientEnum);  _assert_(dragcoeff_input);
 	if(domaintype!=Domain2DverticalEnum){
 		vy_input        = element->GetInput(VyEnum);                   _assert_(vy_input);
 		adjointy_input  = element->GetInput(AdjointyEnum);             _assert_(adjointy_input);
 	}
+	/* get the friction law: 1- Budd, 11-Schoof*/
+	int frictionlaw; element->FindParam(&frictionlaw, FrictionLawEnum);
+	Input* dragcoeff_input = NULL;
+	switch(frictionlaw) {
+		case 1:
+			dragcoeff_input = element->GetInput(FrictionCoefficientEnum); _assert_(dragcoeff_input);
+			break;
+		case 2:
+		case 11:
+			dragcoeff_input = element->GetInput(FrictionCEnum); _assert_(dragcoeff_input);
+			break;
+		default:
+			_error_("Friction law "<< frictionlaw <<" not supported in the inversion.");
+	}
+
 	/* Start  looping on the number of gaussian points: */
 	Gauss* gauss=element->NewGaussBase(4);
@@ -1905,11 +2611,29 @@
 
 		/*Build gradient vector (actually -dJ/dD): */
-		for(int i=0;i<numvertices;i++){
-			if(domaintype!=Domain2DverticalEnum) ge[i]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
-			else ge[i]+=-2.*drag*dalpha2dk*(lambda*vx)*Jdet*gauss->weight*basis[i];
-			_assert_(!xIsNan<IssmDouble>(ge[i]));
-		}
-	}
-	gradient->SetValues(numvertices,vertexpidlist,ge,ADD_VAL);
+		if(control_interp==P1Enum){
+			for(int i=0;i<numvertices;i++){
+				if(domaintype!=Domain2DverticalEnum) ge[i]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
+				else ge[i]+=-2.*drag*dalpha2dk*(lambda*vx)*Jdet*gauss->weight*basis[i];
+				_assert_(!xIsNan<IssmDouble>(ge[i]));
+			}
+		}
+		else if(control_interp==P0Enum){
+			if(domaintype!=Domain2DverticalEnum) ge[0]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight;
+			else ge[0]+=-2.*drag*dalpha2dk*(lambda*vx)*Jdet*gauss->weight;
+			_assert_(!xIsNan<IssmDouble>(ge[0]));
+		}
+		else{
+			_error_("not supported");
+		}
+	}
+	if(control_interp==P1Enum){
+		gradient->SetValues(numvertices,vertexpidlist,ge,ADD_VAL);
+	}
+	else if(control_interp==P0Enum){
+		gradient->SetValue(vertexpidlist[0],ge[0],ADD_VAL);
+	}
+	else{
+		_error_("not supported");
+	}
 
 	/*Clean up and return*/
@@ -1921,8 +2645,8 @@
 	delete friction;
 }/*}}}*/
-void           AdjointHorizAnalysis::GradientJDragSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
+void           AdjointHorizAnalysis::GradientJDragMLHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
 
 	/*return if floating (gradient is 0)*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 
 	/*Intermediaries*/
@@ -1958,5 +2682,122 @@
 	/*Fetch number of vertices for this finite element*/
 	int numvertices = basalelement->GetNumberOfVertices();
-	int frictionlaw;
+
+	/*Initialize some vectors*/
+	IssmDouble* basis         = xNew<IssmDouble>(numvertices);
+	IssmDouble* ge            = xNewZeroInit<IssmDouble>(numvertices);
+	int*        vertexpidlist = xNew<int>(numvertices);
+
+	/*Build friction element, needed later: */
+	Friction* friction=new Friction(basalelement,dim);
+
+	/*Retrieve all inputs we will be needing: */
+	basalelement->GetVerticesCoordinates(&xyz_list);
+	basalelement->GradientIndexing(&vertexpidlist[0],control_index);
+	Input* vx_input        = basalelement->GetInput(VxBaseEnum);                   _assert_(vx_input);
+	Input* vy_input        = basalelement->GetInput(VyBaseEnum);                   _assert_(vy_input);
+	Input* adjointx_input  = basalelement->GetInput(AdjointxBaseEnum);             _assert_(adjointx_input);
+	Input* adjointy_input  = basalelement->GetInput(AdjointyBaseEnum);             _assert_(adjointy_input);
+
+	/* get the friction law: 1- Budd, 11-Schoof*/
+	int frictionlaw;element->FindParam(&frictionlaw, FrictionLawEnum);
+	Input* dragcoeff_input = NULL;
+	switch(frictionlaw) {
+		case 1:
+			dragcoeff_input = basalelement->GetInput(FrictionCoefficientEnum); _assert_(dragcoeff_input);
+			break;
+		case 2:
+		case 11:
+			dragcoeff_input = basalelement->GetInput(FrictionCEnum); _assert_(dragcoeff_input);
+			break;
+		default:
+			_error_("Friction law "<< frictionlaw <<" not supported in the inversion.");
+	}
+
+	/* Start  looping on the number of gaussian points: */
+	Gauss* gauss=basalelement->NewGauss(4);
+	while(gauss->next()){
+
+		adjointx_input->GetInputValue(&lambda, gauss);
+		adjointy_input->GetInputValue(&mu, gauss);
+		vx_input->GetInputValue(&vx,gauss);
+		vy_input->GetInputValue(&vy,gauss);
+		dragcoeff_input->GetInputValue(&drag, gauss);
+
+		friction->GetAlphaComplement(&dalpha2dk,gauss);
+
+		basalelement->JacobianDeterminant(&Jdet,xyz_list,gauss);
+		basalelement->NodalFunctionsP1(basis,gauss);
+
+		/*Build gradient vector (actually -dJ/dD): */
+		if(control_interp==P1Enum){
+			for(int i=0;i<numvertices;i++){
+				ge[i]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
+				_assert_(!xIsNan<IssmDouble>(ge[i]));
+			}
+		}
+		else if(control_interp==P0Enum){
+			ge[0]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight;
+			_assert_(!xIsNan<IssmDouble>(ge[0]));
+		}
+		else{
+			_error_("not supported");
+		}
+	}
+	if(control_interp==P1Enum){
+		gradient->SetValues(numvertices,vertexpidlist,ge,ADD_VAL);
+	}
+	else if(control_interp==P0Enum){
+		gradient->SetValue(vertexpidlist[0],ge[0],ADD_VAL);
+	}
+	else{
+		_error_("not supported");
+	}
+
+	/*Clean up and return*/
+	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(basis);
+	xDelete<IssmDouble>(ge);
+	xDelete<int>(vertexpidlist);
+	delete gauss;
+	delete friction;
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
+}/*}}}*/
+void           AdjointHorizAnalysis::GradientJDragSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
+
+	/*return if floating (gradient is 0)*/
+	if(element->IsAllFloating()) return;
+
+	/*Intermediaries*/
+	int      domaintype,dim;
+	Element* basalelement;
+
+	/*Get basal element*/
+	element->FindParam(&domaintype,DomainTypeEnum);
+	switch(domaintype){
+		case Domain2DhorizontalEnum:
+			basalelement = element;
+			dim          = 2;
+			break;
+		case Domain2DverticalEnum:
+			if(!element->IsOnBase()) return;
+			basalelement = element->SpawnBasalElement();
+			dim          = 1;
+			break;
+		case Domain3DEnum:
+			if(!element->IsOnBase()) return;
+			basalelement = element->SpawnBasalElement();
+			dim          = 2;
+			break;
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+	}
+
+	/*Intermediaries*/
+	IssmDouble Jdet,weight;
+	IssmDouble drag,dalpha2dk;
+	IssmDouble vx,vy,lambda,mu;
+	IssmDouble *xyz_list= NULL;
+
+	/*Fetch number of vertices for this finite element*/
+	int numvertices = basalelement->GetNumberOfVertices();
 
 	/*Initialize some vectors*/
@@ -1977,6 +2818,6 @@
 
 	/* get the friction law: 1- Budd, 11-Schoof*/
-	element->FindParam(&frictionlaw, FrictionLawEnum);
-	Input* dragcoeff_input;
+	int frictionlaw;element->FindParam(&frictionlaw, FrictionLawEnum);
+	Input* dragcoeff_input = NULL;
 	switch(frictionlaw) {
 		case 1:
@@ -2007,10 +2848,27 @@
 
 		/*Build gradient vector (actually -dJ/dD): */
-		for(int i=0;i<numvertices;i++){
-			ge[i]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
-			_assert_(!xIsNan<IssmDouble>(ge[i]));
-		}
-	}
-	gradient->SetValues(numvertices,vertexpidlist,ge,ADD_VAL);
+		if(control_interp==P1Enum){
+			for(int i=0;i<numvertices;i++){
+				ge[i]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
+				_assert_(!xIsNan<IssmDouble>(ge[i]));
+			}
+		}
+		else if(control_interp==P0Enum){
+			ge[0]+=-2.*drag*dalpha2dk*((lambda*vx+mu*vy))*Jdet*gauss->weight;
+			_assert_(!xIsNan<IssmDouble>(ge[0]));
+		}
+		else{
+			_error_("not supported");
+		}
+	}
+	if(control_interp==P1Enum){
+		gradient->SetValues(numvertices,vertexpidlist,ge,ADD_VAL);
+	}
+	else if(control_interp==P0Enum){
+		gradient->SetValue(vertexpidlist[0],ge[0],ADD_VAL);
+	}
+	else{
+		_error_("not supported");
+	}
 
 	/*Clean up and return*/
@@ -2021,11 +2879,12 @@
 	delete gauss;
 	delete friction;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void           AdjointHorizAnalysis::GradientJDragHydroFS(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
 
 	/*return if floating or not on bed (gradient is 0)*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 	if(!element->IsOnBase()) return;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Intermediaries*/
@@ -2124,6 +2983,7 @@
 
 	/*return if floating or not on bed (gradient is 0)*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 	if(!element->IsOnBase()) return;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Intermediaries*/
@@ -2195,5 +3055,6 @@
 
 	/*return if floating (gradient is 0)*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Intermediaries*/
@@ -2314,5 +3175,5 @@
 	delete gauss;
 	delete friction;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void           AdjointHorizAnalysis::GradientJDSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index){/*{{{*/
@@ -2321,4 +3182,5 @@
 	int      domaintype,dim;
 	Element* basalelement;
+	if(control_interp!=P1Enum) _error_("not implemented yet...");
 
 	/*Get basal element*/
@@ -2396,5 +3258,5 @@
 	xDelete<int>(vertexpidlist);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void           AdjointHorizAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
@@ -2403,4 +3265,7 @@
 	if(approximation==FSApproximationEnum || approximation==NoneApproximationEnum){
 		InputUpdateFromSolutionFS(solution,element);
+	}
+	else if (approximation==MLHOApproximationEnum) {
+		InputUpdateFromSolutionMLHO(solution, element);
 	}
 	else{
@@ -2549,4 +3414,77 @@
 	xDelete<int>(doflist);
 }/*}}}*/
+void           AdjointHorizAnalysis::InputUpdateFromSolutionMLHO(IssmDouble* solution,Element* element){/*{{{*/
+	int  i;
+	int* doflist=NULL;
+
+	int    domaintype;
+	element->FindParam(&domaintype,DomainTypeEnum);
+	if (domaintype!=Domain2DhorizontalEnum) _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+
+	/*Fetch number of nodes and dof for this finite element*/
+	int numnodes = element->GetNumberOfNodes();
+	int numdof = numnodes * 4;
+
+	/*Fetch dof list and allocate solution vectors*/
+	element->GetDofListLocal(&doflist,MLHOApproximationEnum,GsetEnum);
+	IssmDouble* values  = xNew<IssmDouble>(numdof);
+	IssmDouble* lambdax = xNew<IssmDouble>(numnodes);
+	IssmDouble* lambday = xNew<IssmDouble>(numnodes);
+	IssmDouble* lambdabx = xNew<IssmDouble>(numnodes);
+	IssmDouble* lambdaby = xNew<IssmDouble>(numnodes);
+	IssmDouble* lambdashx = xNew<IssmDouble>(numnodes);
+	IssmDouble* lambdashy = xNew<IssmDouble>(numnodes);
+	IssmDouble* n			 = xNew<IssmDouble>(numnodes);
+
+	/*Use the dof list to index into the solution vector: */
+	for(i=0;i<numdof;i++) values[i]=solution[doflist[i]];
+
+	/*Transform solution in Cartesian Space*/
+	if(domaintype!=Domain2DverticalEnum)	element->TransformSolutionCoord(&values[0],XYEnum);
+
+	element->GetInputListOnNodes(&n[0],MaterialsRheologyNEnum,0.);
+
+	/*Ok, we have vx and vy in values, fill in vx and vy arrays: */
+	for(i=0;i<numnodes;i++){
+		lambdabx[i] =values[i*4+0];
+		lambdashx[i]=values[i*4+1];
+		/*Check solution*/
+		if(xIsNan<IssmDouble>(lambdabx[i])) _error_("NaN found in solution vector");
+		if(xIsInf<IssmDouble>(lambdabx[i])) _error_("Inf found in solution vector");
+		if(xIsNan<IssmDouble>(lambdashx[i])) _error_("NaN found in solution vector");
+		if(xIsInf<IssmDouble>(lambdashx[i])) _error_("Inf found in solution vector");
+		/* adjoint for the surface velocity */
+		lambdax[i] = lambdabx[i] + lambdashx[i]*(n[i]+1)/(n[i]+2);
+
+		lambdaby[i] =values[i*4+2];
+		lambdashy[i]=values[i*4+3];
+		/*Check solution*/
+		if(xIsNan<IssmDouble>(lambdaby[i])) _error_("NaN found in solution vector");
+		if(xIsInf<IssmDouble>(lambdaby[i])) _error_("Inf found in solution vector");
+		if(xIsNan<IssmDouble>(lambdashy[i])) _error_("NaN found in solution vector");
+		if(xIsInf<IssmDouble>(lambdashy[i])) _error_("Inf found in solution vector");
+		/* adjoint for the surface velocity */
+		lambday[i] = lambdaby[i] + lambdashy[i]*(n[i]+1)/(n[i]+2);
+	}
+
+	/*Add vx and vy as inputs to the tria element: */
+	element->AddInput(AdjointxBaseEnum,lambdabx,element->GetElementType());
+	element->AddInput(AdjointyBaseEnum,lambdaby,element->GetElementType());
+	element->AddInput(AdjointxShearEnum,lambdashx,element->GetElementType());
+	element->AddInput(AdjointyShearEnum,lambdashy,element->GetElementType());
+
+	element->AddInput(AdjointxEnum,lambdax,element->GetElementType());
+	element->AddInput(AdjointyEnum,lambday,element->GetElementType());
+
+	/*Free ressources:*/
+	xDelete<IssmDouble>(values);
+	xDelete<IssmDouble>(lambdax);
+	xDelete<IssmDouble>(lambday);
+	xDelete<IssmDouble>(lambdabx);
+	xDelete<IssmDouble>(lambdaby);
+	xDelete<IssmDouble>(lambdashx);
+	xDelete<IssmDouble>(lambdashy);
+	xDelete<int>(doflist);
+}/*}}}*/
 void           AdjointHorizAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/
 	/*Default, do nothing*/
Index: issm/trunk/src/c/analyses/AdjointHorizAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/AdjointHorizAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/AdjointHorizAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
@@ -27,4 +28,6 @@
 		ElementMatrix* CreateKMatrixFS(Element* element);
 		ElementMatrix* CreateKMatrixHO(Element* element);
+		ElementMatrix* CreateKMatrixMLHO(Element* element);
+		ElementMatrix* CreateKMatrixMLHOVerticalIntergrated(Element* element);
 		ElementMatrix* CreateKMatrixL1L2(Element* element);
 		ElementMatrix* CreateKMatrixSSA(Element* element);
@@ -33,4 +36,5 @@
 		ElementVector* CreatePVectorL1L2(Element* element);
 		ElementVector* CreatePVectorHO(Element* element);
+		ElementVector* CreatePVectorMLHO(Element* element);
 		ElementVector* CreatePVectorSSA(Element* element);
 		void           GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
@@ -41,8 +45,10 @@
 		void           GradientJBbarL1L2(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJBbarHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
+		void           GradientJBbarMLHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJBbarSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJBFS(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJBGradient(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJBHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
+		void           GradientJBMLHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJBSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJDragFS(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
@@ -50,4 +56,5 @@
 		void           GradientJDragL1L2(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJDragHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
+		void           GradientJDragMLHO(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJDragSSA(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
 		void           GradientJDragHydroFS(Element* element,Vector<IssmDouble>* gradient,int control_interp,int control_index);
@@ -59,4 +66,5 @@
 		void           InputUpdateFromSolutionFS(IssmDouble* solution,Element* element);
 		void           InputUpdateFromSolutionHoriz(IssmDouble* solution,Element* element);
+		void           InputUpdateFromSolutionMLHO(IssmDouble* solution,Element* element);
 		void           UpdateConstraints(FemModel* femmodel);
 };
Index: issm/trunk/src/c/analyses/Analysis.h
===================================================================
--- issm/trunk/src/c/analyses/Analysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/Analysis.h	(revision 26744)
@@ -39,9 +39,10 @@
 		virtual void CreateNodes(Nodes* nodes,IoModel* iomodel,bool isamr=false)=0;
 		virtual int  DofsPerNode(int** doflist,int domaintype,int approximation)=0;
-		virtual void UpdateElements(Elements* elements,Inputs* inputs,IoModel* iomodel,int analysis_counter,int analysis_type)=0;
+		virtual void UpdateElements(Elements* elements,Inputs* inputs, IoModel* iomodel,int analysis_counter,int analysis_type)=0;
 		virtual void UpdateParameters(Parameters* parameters,IoModel* iomodel,int solution_enum,int analysis_enum)=0;
 
 		/*Finite element Analysis*/
 		virtual void           Core(FemModel* femmodel)=0;
+		virtual void           PreCore(FemModel* femmodel)=0;
 		virtual ElementVector* CreateDVector(Element* element)=0;
 		virtual ElementMatrix* CreateJacobianMatrix(Element* element)=0;
Index: issm/trunk/src/c/analyses/Balancethickness2Analysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/Balancethickness2Analysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/Balancethickness2Analysis.cpp	(revision 26744)
@@ -32,5 +32,5 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxEnum);
@@ -57,4 +57,7 @@
 /*Finite Element Analysis*/
 void           Balancethickness2Analysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented yet");
+}/*}}}*/
+void           Balancethickness2Analysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented yet");
 }/*}}}*/
Index: issm/trunk/src/c/analyses/Balancethickness2Analysis.h
===================================================================
--- issm/trunk/src/c/analyses/Balancethickness2Analysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/Balancethickness2Analysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
